clear; clc; addpath('../');
% run('../vlfeat-0.9.20/toolbox/vl_setup')

%%% pre-compute database features
fn = dir('./labelsDB_norm/*.jpg');
for i = 1:length(fn)
    imgDB = imread(['./labelsDB_norm/' fn(i).name]);
    [featDB(i).f,featDB(i).d] = vl_sift(single(rgb2gray(imgDB)));
    fprintf('finished %d\n',i);
end
save('featDB.mat','featDB');
load featDB.mat;

numQ = 30; 

matlabpool open 8
parfor_progress(numQ); tic
matchIdx = zeros(1,numQ);
parfor testNum = 1:numQ
    tic
    imgQ = imread(sprintf('./labelsQuery_norm/test%.2d.jpg',testNum));
    [Qf,Qd] = vl_sift(single(rgb2gray(imgQ)));
    fn = dir('./labelsDB_norm/*.jpg');
    numPass = zeros(1,length(fn));
    for i = 1:length(fn)
        matchresult = sift_match_noPlot(Qf,Qd,featDB(i));
        if isempty(matchresult)
            numPass(i) = 0;
        else
            numPass(i) = matchresult.ransac;
        end
    end
    
    [~,idx] = max(numPass);
    matchIdx(testNum) = idx;
    timeRequired(testNum) = toc;
    choice(testNum) = (testNum==idx);
    
    parfor_progress;
end
parfor_progress(0); toc
matlabpool close

correctIdx = find(choice);
wrongIdx = find(~choice);
success_rate = sum(choice)/numQ*100
save('resultsMR.mat');