clear; clc;
% run('./vlfeat-0.9.20/toolbox/vl_setup')

% %%% pre-compute database features
fn = dir('./labelsDB_norm/*.jpg');
for i = 1:length(fn)
    imgDB = imread(['./labelsDB_norm/' fn(i).name]);
    [featDB(i).f,featDB(i).d] = vl_sift(single(rgb2gray(imgDB)));
    fprintf('finished %d\n',i);
end
save('featDB.mat','featDB');
load featDB.mat;

testNum = 2;

tic;
imgQ = imread(sprintf('./labelsQuery_norm/test%.2d.jpg',testNum));
[Qf,Qd] = vl_sift(single(rgb2gray(imgQ)));

fn = dir('./labelsDB_norm/*.jpg');
numPass = zeros(1,length(fn));
for i = 1:length(fn)
    matchresult = sift_match_noPlot(Qf,Qd,featDB(i));
    if isempty(matchresult)
        numPass(i) = 0;
    else
        numPass(i) = matchresult.ransac;
    end
end

[~,idx] = max(numPass);
if testNum == idx
    fprintf('Correctly classified test image #%d in %0.3f s\n',testNum, toc);
end

% plot SIFT match images
featQ.f = Qf; featQ.d = Qd;
imgMatch = imread(['./labelsDB_norm/' fn(idx).name]);
[featMatch.f,featMatch.d] = vl_sift(single(rgb2gray(imgMatch)));
mr = sift_match(imgQ,imgMatch,featQ,featMatch);
