clear; clc;
% run('./vlfeat-0.9.20/toolbox/vl_setup')

%%% pre-compute database features
fn = dir('./data/labelsDB_norm/*.jpg');
for i = 1:length(fn)
    imgDB = imread(['./data/labelsDB_norm/' fn(i).name]);
    [featDB(i).f,featDB(i).d] = vl_sift(single(rgb2gray(imgDB)));
    fprintf('finished %d\n',i);
end
save('featDB.mat','featDB');
load featDB.mat;

distance = 6:6:60;
correctLabel = zeros(3,length(distance));
dbIdx = [66 101 34 15 32];
for imgNum = 1:5
    
    for i = 1:length(distance)
        imgQ = imread(sprintf('./distance/test%d/%d.JPG',imgNum,distance(i)));
        imgQ = imrotate(imgQ,-90);
        [Qf,Qd] = vl_sift(single(rgb2gray(imgQ)));
        
        fn = dir('./data/labelsDB_norm/*.jpg');
        numPass = zeros(1,length(fn));
        
        matlabpool open 8
        parfor_progress(length(fn)); tic
        parfor cnt = 1:length(fn)
            matchresult = sift_match_noPlot(Qf,Qd,featDB(cnt));
            if isempty(matchresult)
                numPass(cnt) = 0;
            else
                numPass(cnt) = matchresult.ransac;
            end
        end
        parfor_progress(0); toc
        matlabpool close
        
        [~,idx] = max(numPass);
        correctLabel(imgNum,i) = (dbIdx(imgNum)==idx);
        
        fprintf('Finished img %d distance %d\t',imgNum,distance(i));
        if correctLabel(imgNum,i)==1
            fprintf('Correct!\n');
        else
            fprintf('Incorrect :(\n');
        end
    end
end

save('resultsDistanceClass.mat','distance','correctLabel');