clear; clc;
% run('./vlfeat-0.9.20/toolbox/vl_setup')

fn = dir('./data/labelsDB_norm/*.jpg');
for i = 1:length(fn)
    imgDB = imread(['./data/labelsDB_norm/' fn(i).name]);
    [featDB(i).f,featDB(i).d] = vl_sift(single(rgb2gray(imgDB)));
    fprintf('finished %d\n',i);
end
save('featDB.mat','featDB');
load featDB.mat;

imgNum = 1;
distance = 60;

% imgDB = imread(sprintf('./distance/label%d.jpg',imgNum));
% [featDB.f,featDB.d] = vl_sift(single(rgb2gray(imgDB)));

imgQ = imread(sprintf('./distance/test%d/%d.JPG',imgNum,distance));
imgQ = imrotate(imgQ,-90);
[Qf,Qd] = vl_sift(single(rgb2gray(imgQ)));

% % plot images for image
% matchresult = sift_match(imgQ,imgDB,featQ,featDB);

%%
fn = dir('./data/labelsDB_norm/*.jpg');
numPass = zeros(1,length(fn));

matlabpool open 8
parfor_progress(length(fn)); tic
parfor cnt = 1:length(fn)
    matchresult = sift_match_noPlot(Qf,Qd,featDB(cnt));
    if isempty(matchresult)
        numPass(cnt) = 0;
    else
        numPass(cnt) = matchresult.ransac;
    end
end
parfor_progress(0); toc
matlabpool close

[~,idx] = max(numPass);

% plot SIFT match images
featQ.f = Qf; featQ.d = Qd;
imgMatch = imread(['./data/labelsDB_norm/' fn(idx).name]);
[featMatch.f,featMatch.d] = vl_sift(single(rgb2gray(imgMatch)));
mr = sift_match_scale(imgQ,imgMatch,featQ,featMatch);