clear; clc;
% run('./vlfeat-0.9.20/toolbox/vl_setup')

%%% pre-compute database features
fn = dir('./data/labelsDB_norm/*.jpg');
for i = 1:length(fn)
    imgDB = imread(['./data/labelsDB_norm/' fn(i).name]);
    [featDB(i).f,featDB(i).d] = vl_sift(single(rgb2gray(imgDB)));
    fprintf('finished %d\n',i);
end
save('featDB.mat','featDB');
load featDB.mat;

correctIdx = [];
wrongIdx = [];
numQ = 100; 

matlabpool open 8
parfor_progress(numQ); tic
parfor testNum = 1:numQ
    tic
    imgQ = imread(sprintf('./data/labelsQuery_norm/test%.3d.jpg',testNum));
    [Qf,Qd] = vl_sift(single(rgb2gray(imgQ)));
    fn = dir('./data/labelsDB_norm/*.jpg');
    numPass = zeros(1,length(fn));
    for i = 1:length(fn)
        matchresult = sift_match_noPlot(Qf,Qd,featDB(i));
        if isempty(matchresult)
            numPass(i) = 0;
        else
            numPass(i) = matchresult.ransac;
        end
        %fprintf('Finished processing database image %d of %d\n',i,length(fn));
    end
    
    [~,idx] = max(numPass);
    timeRequired(testNum) = toc;
    choice(testNum) = (testNum==idx);
    
    %     if testNum == idx
    %         fprintf('Correctly classified test image #%d in %0.3f s\n',testNum, timeRequired(testNum));
    %         correctIdx = [correctIdx testNum];
    %     else
    %         wrongIdx = [wrongIdx testNum];
    %     end
    
    %     % plot images for image
    %     imgMatch = imread(['./data/labelsDB_norm/' fn(idx).name]);
    %     [featMatch.f,featMatch.d] = vl_sift(single(rgb2gray(imgMatch)));
    %     sift_match(imgQ,imgMatch,featQ,featMatch);
    
    parfor_progress;
end
parfor_progress(0); toc
matlabpool close

correctIdx = find(choice);
wrongIdx = find(~choice);
success_rate = sum(choice)/numQ*100
save('resultsMR.mat');