function testMotion()
%%% pre-compute database features
% fn = dir('./data/labelsDB_norm/*.jpg');
% for i = 1:length(fn)
%     imgDB = imread(['./data/labelsDB_norm/' fn(i).name]);
%     [featDB(i).f,featDB(i).d] = vl_sift(single(rgb2gray(imgDB)));
%     fprintf('finished %d\n',i);
% end
% save('featDB.mat','featDB');
load featDB.mat;

motion = 2:2:20;
angle = 0:45:90;

for i = 1:length(motion)
    for j = 1:length(angle)
        success(i,j) = getSuccessRate(featDB,motion(i),angle(j));
    end
end
save('motionResults.mat');
end


function success_rate = getSuccessRate(featDB,motion,angle)

fprintf('Starting motion %d angle %d\n',motion,angle);

numQ = 100;
matlabpool open 8
parfor_progress(numQ); tic
parfor testNum = 1:numQ
    imgQ = imread(sprintf('./data/labelsQuery_norm/motion_%d_%d/test%.3d.jpg',motion,angle,testNum));
    [Qf,Qd] = vl_sift(single(rgb2gray(imgQ)));
    fn = dir('./data/labelsDB_norm/*.jpg');
    numPass = zeros(1,length(fn));
    for i = 1:length(fn)
        matchresult = sift_match_noPlot(Qf,Qd,featDB(i));
        if isempty(matchresult)
            numPass(i) = 0;
        else
            numPass(i) = matchresult.ransac;
        end
    end
    
    [~,idx] = max(numPass);
    choice(testNum) = (testNum==idx);
    parfor_progress;
end
parfor_progress(0); toc
matlabpool close

success_rate = sum(choice)/numQ*100;
end